HDU1257 最少拦截系统 —— 贪心 or LIS(最长上升子序列)

Posted h_z_cong

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了HDU1257 最少拦截系统 —— 贪心 or LIS(最长上升子序列)相关的知识,希望对你有一定的参考价值。

题目链接:http://acm.split.hdu.edu.cn/showproblem.php?pid=1257

 

最少拦截系统

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 45924    Accepted Submission(s): 18118


Problem Description
某国为了防御敌国的导弹袭击,发展出一种导弹拦截系统.但是这种导弹拦截系统有一个缺陷:虽然它的第一发炮弹能够到达任意的高度,但是以后每一发炮弹都不能超过前一发的高度.某天,雷达捕捉到敌国的导弹来袭.由于该系统还在试用阶段,所以只有一套系统,因此有可能不能拦截所有的导弹.
怎么办呢?多搞几套系统呗!你说说倒蛮容易,成本呢?成本是个大问题啊.所以俺就到这里来求救了,请帮助计算一下最少需要多少套拦截系统.
 

 

Input
输入若干组数据.每组数据包括:导弹总个数(正整数),导弹依此飞来的高度(雷达给出的高度数据是不大于30000的正整数,用空格分隔)
 

 

Output
对应每组数据输出拦截所有导弹最少要配备多少套这种导弹拦截系统.
 

 

Sample Input
8 389 207 155 300 299 170 158 65
 

 

Sample Output
2
 

 

Source
 

 

Recommend
JGShining
 
 
 
题解:
 
 
贪心:
技术分享
 1 #include<bits/stdc++.h>
 2 using namespace std;
 3 const int maxn = 1e5;
 4 
 5 int use[maxn], a[maxn];
 6 
 7 int main()
 8 {
 9     int n;
10     while(scanf("%d",&n)!=EOF)
11     {
12         for(int i = 1; i<=n; i++)
13             scanf("%d",&a[i]);
14 
15         int cnt = 0;
16         for(int i = 1; i<=n; i++)
17         {
18             int k = -1, minn = 2e9;
19             for(int j = 1; j<=cnt; j++)
20                 if(use[j]>a[i] && use[j]<minn)
21                     minn = use[k = j];
22 
23             if(k==-1)
24                 use[++cnt] = a[i];
25             else
26                 use[k] = a[i];
27         }
28         printf("%d\n",cnt);
29     }
30 
31     return 0;
32  }
View Code

LIS:

技术分享
 1 #include<bits/stdc++.h>
 2 using namespace std;
 3 const int maxn = 1e5;
 4 
 5 int use[maxn], a[maxn];
 6 
 7 int main()
 8 {
 9     int n;
10     while(scanf("%d",&n)!=EOF)
11     {
12 
13         for(int i = 1; i<=n; i++)
14         scanf("%d",&a[i]);
15 
16         int cnt = 0;
17         for(int i = 1; i<=n; i++)
18         {
19             if(i==1 || a[i]>use[cnt])
20                 use[++cnt] = a[i];
21 
22             else
23             {
24                 int id = lower_bound(use+1,use+1+cnt,a[i]) - (use+1);
25                 use[id+1] = a[i];
26             }
27         }
28         printf("%d\n",cnt);
29     }
30 
31     return 0;
32  }
View Code

 






以上是关于HDU1257 最少拦截系统 —— 贪心 or LIS(最长上升子序列)的主要内容,如果未能解决你的问题,请参考以下文章

HDU-1257 最少拦截系统 ( 贪心 )

HDU - 1257 最少拦截系统(贪心) 解题

HDU 1257 最少拦截系统(贪心)

hdu1257最少拦截系统 贪心

HDU 1257 最少拦截系统 贪心

HDU - 1257 最少拦截系统(dp或贪心)